// Car Sentry stream listener (using CuriousTech PngMagic)
// Displays volts, temp and input status and sends command to sleep

browser = 'C:\\Program Files (x86)\\Google\\Chrome\\Application\\chrome.exe'

pass = 'password'   // current devicePassword

lowVoltWarning = 12.10

Pm.Window('CarSentry')

Gdi.Width = 230 // resize drawing area (30 hours at 10mins, 63 at 20mins)
Gdi.Height = 150

var last
var Json
var tarray
var rharray
var varray
var timeArray

if( typeof(varray) != 'object')
	varray = []
if( typeof(tarray) != 'object')
	tarray = []
if( typeof(rharray) != 'object')
	rharray = []
if( typeof(timeArray) != 'object')
	timeArray = []

date = new Date()
lastDate = date
event = ''
error = 0
load = false
margin = 28
cnt = 5 // 5 second counter
tog = 0
Url = ''
Pm.SetTimer(1000) // redraw and delay for open
heartbeat = date.valueOf()
Draw()

// Handle published events
function OnCall(msg, event, data, a2)
{
	switch(msg)
	{
		case 'HTTPCONNECTED':
//			Pm.Echo('CS connected')
			break
		case 'HTTPDATA':
			heartbeat = (new Date()).valueOf()
			error = 0
			procLine(data)
			break
		case 'HTTPSTATUS':
			Pm.Echo('CS status ' + event)
			break
		case 'HTTPCLOSE':
//			Pm.Echo('CS closed')
			Url = ''
			break
		case 'CHECK':
			csIP = event // IP from car
//			if(csIP.substr(0,7) =='192.168')
//				csIP = '192.168.0.110'
			Url = 'ws://' +csIP + '/ws'
//Pm.Echo('CS CHECK ' + event)
			if(Http.Connected )
			{
Pm.Echo('CS close')
				Http.Close()
			}
			lat = data
			lon = a2
			cnt = 2 // called by server.  It takes 2 seconds from powerup to get all the readings
			break
		case 'BUTTON':
			switch(event)
			{
				case 0: // Open Page
					load = true
					break
				case 1:
					if(Reg.sleepTime <71) Reg.sleepTime ++
					break
				case 2:
					if(Reg.sleepTime) Reg.sleepTime --
					break
				case 3:
					if(Reg.sleepTime2 <71) Reg.sleepTime2 ++
					break
				case 4:
					if(Reg.sleepTime2) Reg.sleepTime2 --
					break
			}
			Draw()
			break
	}
}

function procLine(data)
{
	if(data.length < 2) return
	data = data.replace(/\n|\r/g, "")
	parts = data.split(';')
	lastDate = new Date()

	switch(parts[0])
	{
		case 'state':
//Pm.Echo( lastDate + ' ' + parts[1])
			LogCS(parts[1])
			if(load) // if Open Page was clicked, open the CarSentry in browser (holds power on)
			{
				Pm.Run(browser, 'http://' + csIP)
//				Pm.Run(browser, 'http://' + csIP + '?key=esp8266ct&u=1')
				load = false
			}
			else if(Json.v > 0.1 ) // (if 0, wait for next send)
			{
//Pm.Echo('CS sleep')
				s =  'cmd;{"key":"' + pass + '",'
				s += '"TO":'+ Reg.sleepTime + ','
				s += '"TO2":'+ Reg.sleepTime2 + ','
				s += '"sleep":2'
				s += '}'
				Http.Send( s )
				Http.Close()
			}
			Draw()
			break
		case 'set':
			str = parts[1]
			setJson = !(/[^,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]/.test(
				str.replace(/"(\\.|[^"\\])*"/g, ''))) && eval('(' + str + ')')

//			Reg.sleepTime = setJson.to
//			Reg.sleepTime2 = setJson.to2
//			Pm.Echo('CS ' + data)
			break
		case 'print':
			Pm.Echo( 'CS Print: ' + parts[1])
			break
		case 'alert':
			Pm.Echo( 'CS Alert: ' + parts[1])
			Pm.PlaySound('C:\\AndroidShare\\Media\\Audio\\Notifications\\Krypton.wav')
			break
	}
}

function OnTimer()
{
	time = (new Date()).valueOf()
	if(time - heartbeat > Reg.sleepTime * 60 * 1000)
		error = 1
	if(cnt > 0)
		if(--cnt == 0)
		{
//Pm.Echo('CS conn=' + Http.Connected + ' ' + Http.Timeout)
			if(!Http.Connected && Url != '')
				Http.Connect( 'event', Url )  // Start the event stream
		}
	Draw()
}

function LogCS( str )
{
	Json = !(/[^,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]/.test(
		str.replace(/"(\\.|[^"\\])*"/g, ''))) && eval('(' + str + ')')

	if( Json.v <= 0.03) return

	if(Json.v <= lowVoltWarning)
	{
		Pm.PlaySound('C:\\AndroidShare\\Media\\Audio\\Notifications\\short-notice.mp3')
		Pm.Echo('Car battery voltage is ' + Json.v)
	}

	if(Reg.CarLat != Json.lat + ',' + Json.lon)
	{
		date = new Date()
		Reg.CarLat = Json.lat + ',' + Json.lon
		Reg.CarLatDate = date
		Pm.Log('CarLocation.log', (date.valueOf() / 1000).toFixed() + ',' + Json.lat + ',' + Json.lon)
	}

	varray.push( Json.v )
	tarray.push( Json.ct )
	rharray.push( Json.rh )
	date = new Date()
	timeArray.push( (date.valueOf() / 1000).toFixed() )

	if(varray.length > Gdi.Width - margin*2 )
	{
		varray.shift()
		tarray.shift()
		rharray.shift()
		timeArray.shift()
	}
}

function Draw()
{
	Gdi.Clear(0) // transaprent

	// window border
	Gdi.Brush( Gdi.Argb( 160, 0, 0, 0) )
	Gdi.FillRectangle(0, 0, Gdi.Width-1, Gdi.Height-1)
	Gdi.Pen( Gdi.Argb(255, 0, 0, 255), 1 )
	Gdi.Rectangle(0, 0, Gdi.Width-1, Gdi.Height-1)

	// Title
	Gdi.Font( 'Courier New', 15, 'BoldItalic')
	Gdi.Brush( Gdi.Argb(255, 255, 230, 25) )
	Gdi.Text( 'Car Sentry', 5, 1 )

	Gdi.Brush( Gdi.Argb(255, 255, 0, 0) )
	Gdi.Text( 'X', Gdi.Width-17, 1 )

	Gdi.Font( 'Arial' , 11, 'Regular')
	Gdi.Brush( Gdi.Argb(255, 255, 255, 255) )

	x = 5
	y = 20
	if(Json != undefined) // no data yet
	{
		tog = !tog
		Gdi.Brush( (error&&tog) ? Gdi.Argb(255, 255, 0, 0) : Gdi.Argb(255, 255, 255, 255) )

		Gdi.Text( lastDate.toLocaleTimeString(), Gdi.Width-84, 2 )

		Gdi.Brush( Gdi.Argb(255, 255, 255, 255) )
		Gdi.Font( 'Arial' , 12, 'Regular')
		s = Json.ct + '   ' + Json.rh +'%  ' + Json.v + 'V'
		Reg.CarStat = s
		Gdi.Text( Json.ct + '   ' + Json.rh +'%  ', x, y)

		Gdi.Brush( (+Json.v <= lowVoltWarning && tog) ? Gdi.Argb(255, 255, 0, 0) : Gdi.Argb(255, 255, 255, 255) )
		Gdi.Text( Json.v + 'V' , x + 80, y)

		Gdi.Brush( Gdi.Argb(255, 255, 255, 255) )
		y += 15
		x = 2
		Gdi.Text( ' In:', x, y+1)
		x += 20
		Gdi.Text( Json.lat, x+ 110, y-18)
		Gdi.Text( Json.lon, x+ 106, y-6)
		Gdi.Font( 'Courier New', 15, 'BoldItalic')

		Gdi.Brush( Json.in12v ? Gdi.Argb(255, 255, 0, 0) : Gdi.Argb(255, 255, 255, 255) )
		Gdi.Text( (Json.in12v ? 'On':'Off') , x, y)
		x += 36
		Gdi.Brush( Json.in12 ? Gdi.Argb(255, 255, 0, 0) : Gdi.Argb(255, 255, 255, 255) )
		Gdi.Text( (Json.in1 ? 'On':'Off') , x, y)
		x += 36
		Gdi.Brush( Json.in2 ? Gdi.Argb(255, 255, 0, 0) : Gdi.Argb(255, 255, 255, 255) )
		Gdi.Text( (Json.in2 ? 'On':'Off') , x, y)
		Gdi.Brush( Gdi.Argb(255, 255, 255, 255) )
		y += 16
		x = 2
		Gdi.Font( 'Arial' , 12, 'Regular')
		s = '                USB:     ACC:    Val:'
		Gdi.Text( s, x, y)
		Gdi.Font( 'Arial' , 12, 'Bold')
		states=['Idle', 1, 2, 3, 'WaitCom' ,'Run', 'SDT', 'SB', 'Standby', 9,10,'TO', 'OT']
		x = 6
		Gdi.Brush( Json.state ? Gdi.Argb(255, 255, 0, 0) : Gdi.Argb(255, 255, 255, 255) )
		if(+Json.state > 12)
			Gdi.Text( +Json.state, x, y)
		else
			Gdi.Text( states[+Json.state], x, y)
		Gdi.Brush( Json.usb ? Gdi.Argb(255, 255, 0, 0) : Gdi.Argb(255, 255, 255, 255) )
		x += 82
		Gdi.Text( Json.usb, x, y)
		Gdi.Brush( Json.acc ? Gdi.Argb(255, 255, 0, 0) : Gdi.Argb(255, 255, 255, 255) )
		x += 46
		Gdi.Text( Json.acc, x, y)
		Gdi.Brush( Json.vl ? Gdi.Argb(255, 255, 0, 0) : Gdi.Argb(255, 255, 255, 255) )
		x += 38
		Gdi.Text( Json.vl, x, y)
		Gdi.Brush(  Gdi.Argb(255, 255, 255, 255) )
	}

	Gdi.Font( 'Arial' , 12, 'Regular')
	y = Gdi.Height - 22
	drawButton(load ? 'Waiting...' :'Open Page', 1, y, 70, 16)

	x = Gdi.Width - 144
	Gdi.Text( 'mins ' + Reg.sleepTime, x, y)
	drawButton('+', x+=46, y, 20, 16)
	drawButton('-', x+=20, y, 20, 16)
	x += 20
	Gdi.Text( Reg.sleepTime2, x, y)
	drawButton('+', x+=17, y, 20, 16)
	drawButton('-', x+=20, y, 20, 16)

	x = margin
	y = Gdi.Height - 26
	h = 50
	Gdi.Pen( Gdi.Argb(255, 170, 170, 255),1 ) // border
	Gdi.Rectangle(x-1, y-h-1, Gdi.Width - x - margin + 2, h+1)

	daySep(x, y)
	drawArray(rharray, x, y, 20, 20, Gdi.Argb(255, 0, 255, 255),0 )
	drawArray(tarray, x, y, 56, 56, Gdi.Argb(255, 0, 0, 255), 1 ) // temp
	drawArray(varray, x, y, 12, 12, Gdi.Argb(255, 255, 50, 50), 2 ) // volts
}

function drawArray(arr, x, y, low, high, c, t)
{
	Gdi.Pen( c,1 )
	Gdi.Brush( c )

	h = 50
	for(i = 0; i < arr.length; i++)
	{
		if(arr[i] > high) high = arr[i]
		if(arr[i] < low) low = arr[i]
	}
	switch(t)
	{
		case 2: // volts
			Gdi.Text(low.toFixed(1) , 0, y-10)
			Gdi.Text(high.toFixed(1), 0, y-h-5)
			break
		case 1: // temp
			Gdi.Text(low, Gdi.Width-margin, y-10)
			Gdi.Text(high, Gdi.Width-margin, y-h-5)
			break
	}
	r = high-low
	n = y - ( (arr[0]-low) * h / r ).toFixed(1)
	for(i = 1; i < arr.length; i++)
	{
		n1 = y - ((arr[i]-low) * h / r).toFixed(1)
		Gdi.Line(x + i, n, x + i + 1, n1 )
		n = n1
	}
}

function daySep( x, y)
{
	h = 50
	date = new Date(timeArray[0] * 1000)
	for(i = 1; i < timeArray.length; i++)
	{
		date2 = new Date(timeArray[i] * 1000)

		if(date.getHours() != date2.getHours() && !(date2.getHours() &1))
		{
			c = Gdi.Argb(20, 255, 255, 255 )
			if( date2.getHours() == 0) c = Gdi.Argb(255, 255, 255, 255 )
			if( date2.getHours() == 12) c = Gdi.Argb(120, 255, 200, 200 )
			Gdi.Pen(c, 1)
			Gdi.Line(x + i, y-h, x + i, y )
		}
		date = date2
		date2 = null
	}
	date = null
}

function drawButton(text, x, y, w, h)
{
	Gdi.GradientBrush( 0,y, 22, 24, Gdi.Argb(200, 200, 200, 255), Gdi.Argb(200, 60, 60, 255 ), 90)
	Gdi.FillRectangle( x, y, w-2, h, 3)
	ShadowText( text, x+(w/2), y, Gdi.Argb(255, 255, 255, 255) )
	Pm.Button(x, y, w, h)
}

function ShadowText(str, x, y, clr)
{
	Gdi.Brush( Gdi.Argb(255, 0, 0, 0) )
	Gdi.Text( str, x+1, y+1, 'Center')
	Gdi.Brush( clr )
	Gdi.Text( str, x, y, 'Center')
}
 